com.jnape.palatable.lambda.semigroup.builtin

## Class Min<A extends Comparable<A>>

- java.lang.Object
- - com.jnape.palatable.lambda.semigroup.builtin.Min<A>

- Type Parameters:
    `A` - the value type
  All Implemented Interfaces:
    Fn1<A,Fn1<A,A>>, Fn2<A,A,A>, Applicative<Fn1<A,A>,Fn1<A,?>>, Cartesian<A,Fn1<A,A>,Fn1<?,?>>, Cocartesian<A,Fn1<A,A>,Fn1<?,?>>, Contravariant<A,Profunctor<?,Fn1<A,A>,Fn1<?,?>>>, Functor<Fn1<A,A>,Fn1<A,?>>, Profunctor<A,Fn1<A,A>,Fn1<?,?>>, Monad<Fn1<A,A>,Fn1<A,?>>, MonadReader<A,Fn1<A,A>,Fn1<A,?>>, MonadRec<Fn1<A,A>,Fn1<A,?>>, MonadWriter<A,Fn1<A,A>,Fn1<A,?>>, Semigroup<A>

      public final class Min<A extends Comparable<A>>
      extends Object
      implements Semigroup<A>

  A `Semigroup` over `A` that chooses between two values `x` and `y` via the following rules:
  - If `x` is strictly greater than `y`, return `y`
  - Otherwise, return `x`
  See Also:
    `MinBy`, `Max`

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `A` | `checkedApply(A x, A y)`
    `static <A extends Comparable<A>> Min<A>` | `min()`
    `static <A extends Comparable<A>> Fn1<A,A>` | `min(A x)`
    `static <A extends Comparable<A>> A` | `min(A x, A y)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.jnape.palatable.lambda.semigroup.Semigroup

      `flip, foldLeft, foldRight`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn2

      `apply, apply, checkedApply, compose, contraMap, curried, curry, diMapL, discardR, fn2, fromBiFunction, toBiFunction, uncurry, widen`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn1

      `andThen, carry, cartesian, censor, choose, cocartesian, diMap, diMapR, discardL, flatMap, fmap, fn1, fromFunction, lazyZip, listens, local, pure, pureFn1, thunk, toFunction, trampolineM, zip, zip`

    - ### Methods inherited from interface com.jnape.palatable.lambda.monad.Monad

      `join`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functor.Functor

      `coerce`

- - ### Method Detail

    - #### checkedApply

          public A checkedApply(A x,
                                A y)

      Specified by:
        `checkedApply` in interface `Fn2<A extends Comparable<A>,A extends Comparable<A>,A extends Comparable<A>>`

    - #### min

          public static <A extends Comparable<A>> Min<A> min()

    - #### min

          public static <A extends Comparable<A>> Fn1<A,A> min(A x)

    - #### min

          public static <A extends Comparable<A>> A min(A x,
                                                        A y)